#include <DRV8835MotorShield.h>
#include <Metro.h>

#include <AmariNeuron.h>
#include <AmariOscillator.h>
#define PotentiometerPort 5

int tau1=400;
int tau2=405;
float h_u=-0.0555;
float beta_u=6.05;
float c_uu=1.4;
float c_n_u=0.09;
float h_v=-1;
float beta_v=6.95;
float c_vv=0.2;
float c_n_v=0.09;
float c_uv=1.57;
float c_vu=-1.57;


AmariOscillator osci_1(tau1, h_u, beta_u, c_uu, c_n_u, h_v, beta_v,c_vv, c_n_v, c_uv,c_vu)
;
AmariOscillator osci_2(tau2, h_u, beta_u, c_uu, c_n_u, h_v, beta_v,c_vv, c_n_v, c_uv,c_vu);
DRV8835MotorShield motors;
int speed1=300;
int speed2=300;
int faderValue;
float coupling;
boolean touch;
int index_1,index_2;
int ctr=0;
Metro serialMetro;


void setup()
{
  Serial.begin(115200);
  serialMetro = Metro(50);
  pinMode(2, INPUT);
  osci_1.addHardwareOutputDigital(13);
  osci_2.addHardwareOutputDigital(12);
  index_1=osci_1.addSoftwareInput_v(0);
  osci_1.addSoftwareWeight_v(0);
  index_2=osci_2.addSoftwareInput_v(0);
  osci_2.addSoftwareWeight_v(0);
  osci_1.neuron_u->u=1;
  osci_1.neuron_v->u=-1;
  osci_2.neuron_u->u=-1;
  osci_2.neuron_v->u=1;
}
void loop()
{
  faderValue=analogRead(PotentiometerPort);
 
  coupling=2*faderValue/1024.-1; 
  osci_1.setSoftwareWeight_v(index_1,coupling);
  osci_2.setSoftwareWeight_v(index_2,coupling);
  osci_1.setSoftwareInput_v(index_1,osci_2.neuron_u->output);
  osci_2.setSoftwareInput_v(index_2,osci_1.neuron_u->output);
  osci_1.compute();
  osci_2.compute();
 if (serialMetro.check() )
  {
    Serial.print( osci_1.neuron_u->output*1000);
    // space
    Serial.print(" ");
    Serial.print(coupling);
    Serial.print(" ");
    Serial.print(osci_2.neuron_u->output*1000);
  }
  Serial.println();
  speed1= 100*(osci_1.neuron_u->output>0.5?1:-1);
  speed2= 100*(osci_2.neuron_u->output>0.5?1:-1);
  motors.setM1Speed(speed1);
  motors.setM2Speed(speed2);
}






